﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;

namespace Library.DataModel {

    [MetadataType(typeof(BookMetadata))]
    [CustomValidation(typeof(BookRules), "EnsureOnShelfIsNotMarkedMissing")]
    public partial class Book {

        private static class BookMetadata {

            [Required]
            public static readonly object Title = null;

            [Required]
            public static readonly object Author = null;

            [Required]
            [CustomValidation(typeof(BookRules), "EnsureMeaningfulDescription")]
            public static readonly object Description = null;

            [Required]
            public static readonly object ASIN = null;
        }
    }
}
