﻿// DomainServiceExtensions.cs
//


namespace System.Web.DomainServices
{
    public static class DomainServiceExtensions
    {
        public static void AssociateOriginal(this DomainService domainService, object current, object original)
        {
            if (domainService == null)
            {
                throw new ArgumentNullException("domainService");
            }

            if (current == null)
            {
                throw new ArgumentNullException("current");
            }

            if (original == null)
            {
                throw new ArgumentNullException("original");
            }

            IDomainServiceProxy domainServiceProxy = domainService as IDomainServiceProxy;

            if (domainServiceProxy == null)
            {
                throw new ArgumentException("The AssociateOriginal extension method can only be used with DomainService proxies that implement IDomainServiceProxy.", "domainService");
            }

            domainServiceProxy.CurrentOriginalEntityMap[current] = original;
        }
    }
}
