﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Ria.Data;
using Library.Web;

namespace Library {

    public partial class MainPage : UserControl {

        private ProgressDialog _progressDialog;

        public MainPage() {
            InitializeComponent();
        }

        private void OnLoadButtonClick(object sender, RoutedEventArgs e) {
            booksDataSource.Load();
        }

        private void OnSaveButtonClick(object sender, RoutedEventArgs e) {
            booksDataSource.SubmitChanges();
        }

        private void OnBooksDataSourceLoadingData(object sender, System.Windows.Controls.LoadingDataEventArgs e) {
            _progressDialog = new ProgressDialog("Loading...");
            _progressDialog.Show();
        }

        private void OnBooksDataSourceLoadedData(object sender, LoadedDataEventArgs e) {
            _progressDialog.Close();
        }

        private void OnBooksDataSourceSubmittingChanges(object sender, SubmittingChangesEventArgs e) {
            _progressDialog = new ProgressDialog("Saving...");
            _progressDialog.Show();
        }

        private void OnBooksDataSourceSubmittedChanges(object sender, SubmittedChangesEventArgs e) {
            _progressDialog.Close();
        }

        private void OnBookshelfSelectionChanged(object sender, SelectionChangedEventArgs e) {
            Book book = (Book)((Accordion)sender).SelectedItem;

            booksDataSource.DataView.MoveCurrentTo(book);
        }

        private void OnAddButtonClick(object sender, RoutedEventArgs e) {
            Book book = new Book();

            ((Bookshelf)booksDataSource.DomainContext).Books.Add(book);
            booksDataSource.DataView.MoveCurrentTo(book);
        }
    }
}
