﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.DomainServices;
using Library.Services;
using Library.Models;

namespace Library.Controllers {

    [HandleError]
    public class HomeController : Controller {

        private LibraryService _libraryService;

        public HomeController() {
            _libraryService = DomainServiceProxy.Create<LibraryService>();
        }

        public ActionResult Index() {
            return View("Index", _libraryService.GetBooks());
        }

        public ActionResult About() {
            return View();
        }

        public ActionResult Details(int id) {
            var q = _libraryService.GetBooks();
            Book book = q.Where(b => b.BookID == id).FirstOrDefault();

            return View(book);
        }

        public ActionResult Edit(int id) {
            var q = _libraryService.GetBooks();
            Book book = q.Where(b => b.BookID == id).FirstOrDefault();

            return View(book);
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Edit(Book book, Book orginal) {
            if (ModelState.IsValid) {
                _libraryService.AssociateOriginal(book, orginal);
                _libraryService.UpdateBook(book);
                return RedirectToAction("Details", new {
                    id = book.BookID
                });
            }

            return View(book);
        }

        protected override void Dispose(bool disposing) {
            if (disposing) {
                _libraryService.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}
