﻿// MetaEntity.cs
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.Serialization;
using System.Windows.Ria.Data;

namespace System.Windows.Ria.Sync.Offline {

    [EditorBrowsable(EditorBrowsableState.Never)]
    [DataContract]
    public class MetaEntity {

        public MetaEntity() {
        }

        public MetaEntity(Entity entity) {
            OriginalEntity = entity.GetOriginal();
            CurrentEntity = entity;
            EntityState = entity.EntityState;
            EntityActions = ConvertToOfflinableEntityActions(entity.Actions);
        }

        [DataMember]
        public Entity OriginalEntity {
            get;
            set;
        }

        [DataMember]
        public Entity CurrentEntity {
            get;
            set;
        }

        [DataMember]
        public EntityState EntityState {
            get;
            set;
        }

        [DataMember]
        public IEnumerable<MetaEntityAction> EntityActions {
            get;
            set;
        }

        private IEnumerable<MetaEntityAction> ConvertToOfflinableEntityActions(IEnumerable<EntityAction> entityActions) {
            List<MetaEntityAction> offlineEntityActions = new List<MetaEntityAction>();

            foreach (EntityAction action in entityActions) {
                offlineEntityActions.Add(new MetaEntityAction(action.Name, action.HasParameters, action.Parameters.ToArray()));
            }
            return offlineEntityActions;
        }
    }
}
